diff --git a/src/backend/replication/logical/snapbuild.c b/src/backend/replication/logical/snapbuild.c
index b8992234924..254f0e1aa9d 100644
--- a/src/backend/replication/logical/snapbuild.c
+++ b/src/backend/replication/logical/snapbuild.c
@@ -128,6 +128,7 @@
 #include "access/heapam_xlog.h"
 #include "access/transam.h"
 #include "access/xact.h"
+#include "commands/repack.h"
 #include "common/file_utils.h"
 #include "miscadmin.h"
 #include "pgstat.h"
@@ -982,6 +983,13 @@ SnapBuildCommitTxn(SnapBuild *builder, XLogRecPtr lsn, TransactionId xid,
 		}
 	}
 
+	/*
+	 * REPACK decoding worker may need timetravel anytime. It takes
+	 * responsibility for tracking transaction commits, see below.
+	 */
+	else if (AmRepackWorker())
+		needs_timetravel = true;
+
 	for (nxact = 0; nxact < nsubxacts; nxact++)
 	{
 		TransactionId subxid = subxacts[nxact];
@@ -989,8 +997,12 @@ SnapBuildCommitTxn(SnapBuild *builder, XLogRecPtr lsn, TransactionId xid,
 		/*
 		 * Add subtransaction to base snapshot if catalog modifying, we don't
 		 * distinguish to toplevel transactions there.
+		 *
+		 * See comments on REPACK worker below.
 		 */
-		if (SnapBuildXidHasCatalogChanges(builder, subxid, xinfo))
+		if (SnapBuildXidHasCatalogChanges(builder, subxid, xinfo) ||
+			(AmRepackWorker() &&
+			 ReorderBufferXidHasHeapChanges(builder->reorder, xid)))
 		{
 			sub_needs_timetravel = true;
 			needs_snapshot = true;
@@ -1018,8 +1030,18 @@ SnapBuildCommitTxn(SnapBuild *builder, XLogRecPtr lsn, TransactionId xid,
 		}
 	}
 
-	/* if top-level modified catalog, it'll need a snapshot */
-	if (SnapBuildXidHasCatalogChanges(builder, xid, xinfo))
+	/*
+	 * If top-level modified catalog, it'll need a snapshot.
+	 *
+	 * If we're decoding changes on behalf of REPACK (CONCURRENTLY), only
+	 * changes of the relation being processed are decoded - see
+	 * heap_decode(). Thus any heap change we find here must belong to that
+	 * relation. Add the transaction so that we can keep building snapshots to
+	 * scan that relation.
+	 */
+	if (SnapBuildXidHasCatalogChanges(builder, xid, xinfo) ||
+		(AmRepackWorker() &&
+		 ReorderBufferXidHasHeapChanges(builder->reorder, xid)))
 	{
 		elog(DEBUG2, "found top level transaction %u, with catalog changes",
 			 xid);
@@ -1187,7 +1209,7 @@ SnapBuildProcessRunningXacts(SnapBuild *builder, XLogRecPtr lsn, xl_running_xact
 		xmin = running->oldestRunningXid;
 	elog(DEBUG3, "xmin: %u, xmax: %u, oldest running: %u, oldest xmin: %u",
 		 builder->xmin, builder->xmax, running->oldestRunningXid, xmin);
-	LogicalIncreaseXminForSlot(lsn, xmin);
+	LogicalIncreaseXminForSlot(lsn, xmin, true);
 
 	/*
 	 * Also tell the slot where we can restart decoding from. We don't want to
diff --git a/src/backend/replication/pgrepack/pgrepack.c b/src/backend/replication/pgrepack/pgrepack.c
index 959551f5724..4b205bba241 100644
--- a/src/backend/replication/pgrepack/pgrepack.c
+++ b/src/backend/replication/pgrepack/pgrepack.c
@@ -30,7 +30,8 @@ static void repack_commit_txn(LogicalDecodingContext *ctx,
 static void repack_process_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 								  Relation relation, ReorderBufferChange *change);
 static void repack_store_change(LogicalDecodingContext *ctx, Relation relation,
-								ConcurrentChangeKind kind, HeapTuple tuple);
+								ConcurrentChangeKind kind, HeapTuple tuple,
+								BlockNumber old_blknum);
 
 void
 _PG_output_plugin_init(OutputPluginCallbacks *cb)
@@ -64,6 +65,9 @@ repack_startup(LogicalDecodingContext *ctx, OutputPluginOptions *opt,
 	dstate->change_cxt = AllocSetContextCreate(ctx->context,
 											   "REPACK - change",
 											   ALLOCSET_DEFAULT_SIZES);
+	dstate->snapshot_cxt = AllocSetContextCreate(ctx->context,
+												 "REPACK - snapshot",
+												 ALLOCSET_DEFAULT_SIZES);
 	/* repack_setup_logical_decoding fills in the rest */
 	ctx->output_writer_private = dstate;
 
@@ -133,7 +137,8 @@ repack_process_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 				if (newtuple == NULL)
 					elog(ERROR, "incomplete insert info");
 
-				repack_store_change(ctx, relation, CHANGE_INSERT, newtuple);
+				repack_store_change(ctx, relation, CHANGE_INSERT, newtuple,
+									InvalidBlockNumber);
 			}
 			break;
 		case REORDER_BUFFER_CHANGE_UPDATE:
@@ -148,9 +153,11 @@ repack_process_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 					elog(ERROR, "incomplete update info");
 
 				if (oldtuple != NULL)
-					repack_store_change(ctx, relation, CHANGE_UPDATE_OLD, oldtuple);
+					repack_store_change(ctx, relation, CHANGE_UPDATE_OLD, oldtuple,
+										InvalidBlockNumber);
 
-				repack_store_change(ctx, relation, CHANGE_UPDATE_NEW, newtuple);
+				repack_store_change(ctx, relation, CHANGE_UPDATE_NEW, newtuple,
+									change->data.tp.old_blknum);
 			}
 			break;
 		case REORDER_BUFFER_CHANGE_DELETE:
@@ -162,7 +169,8 @@ repack_process_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 				if (oldtuple == NULL)
 					elog(ERROR, "incomplete delete info");
 
-				repack_store_change(ctx, relation, CHANGE_DELETE, oldtuple);
+				repack_store_change(ctx, relation, CHANGE_DELETE, oldtuple,
+									InvalidBlockNumber);
 			}
 			break;
 		default:
@@ -189,7 +197,8 @@ repack_process_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
  */
 static void
 repack_store_change(LogicalDecodingContext *ctx, Relation relation,
-					ConcurrentChangeKind kind, HeapTuple tuple)
+					ConcurrentChangeKind kind, HeapTuple tuple,
+					BlockNumber old_blknum)
 {
 	RepackDecodingState *dstate;
 	MemoryContext oldcxt;
@@ -285,6 +294,9 @@ repack_store_change(LogicalDecodingContext *ctx, Relation relation,
 	 */
 	BufFileWrite(file, &tuple->t_len, sizeof(tuple->t_len));
 	BufFileWrite(file, tuple->t_data, tuple->t_len);
+	/* If old_blknum is specified, write it too. */
+	if (old_blknum != InvalidBlockNumber)
+		BufFileWrite(file, &old_blknum, sizeof(old_blknum));
 
 	/* Then, write the number of external attributes we found. */
 	natt_ext = list_length(attrs_ext);
diff --git a/src/backend/utils/misc/guc_tables.c b/src/backend/utils/misc/guc_tables.c
index 290ccbc543e..8a48172ea57 100644
--- a/src/backend/utils/misc/guc_tables.c
+++ b/src/backend/utils/misc/guc_tables.c
@@ -44,6 +44,7 @@
 #include "commands/async.h"
 #include "commands/extension.h"
 #include "commands/event_trigger.h"
+#include "commands/repack.h"
 #include "commands/tablespace.h"
 #include "commands/trigger.h"
 #include "commands/user.h"
diff --git a/src/include/access/tableam.h b/src/include/access/tableam.h
index f2c36696bca..132248c5d43 100644
--- a/src/include/access/tableam.h
+++ b/src/include/access/tableam.h
@@ -666,12 +666,12 @@ typedef struct TableAmRoutine
 											  Relation OldIndex,
 											  bool use_sort,
 											  TransactionId OldestXmin,
-											  Snapshot snapshot,
 											  TransactionId *xid_cutoff,
 											  MultiXactId *multi_cutoff,
 											  double *num_tuples,
 											  double *tups_vacuumed,
-											  double *tups_recently_dead);
+											  double *tups_recently_dead,
+											  void *tableam_data);
 
 	/*
 	 * React to VACUUM command on the relation. The VACUUM can be triggered by
@@ -1733,8 +1733,6 @@ table_relation_copy_data(Relation rel, const RelFileLocator *newrlocator)
  *   not needed for the relation's AM
  * - *xid_cutoff - ditto
  * - *multi_cutoff - ditto
- * - snapshot - if != NULL, ignore data changes done by transactions that this
- *	 (MVCC) snapshot considers still in-progress or in the future.
  *
  * Output parameters:
  * - *xid_cutoff - rel's new relfrozenxid value, may be invalid
@@ -1747,19 +1745,19 @@ table_relation_copy_for_cluster(Relation OldTable, Relation NewTable,
 								Relation OldIndex,
 								bool use_sort,
 								TransactionId OldestXmin,
-								Snapshot snapshot,
 								TransactionId *xid_cutoff,
 								MultiXactId *multi_cutoff,
 								double *num_tuples,
 								double *tups_vacuumed,
-								double *tups_recently_dead)
+								double *tups_recently_dead,
+								void *tableam_data)
 {
 	OldTable->rd_tableam->relation_copy_for_cluster(OldTable, NewTable, OldIndex,
 													use_sort, OldestXmin,
-													snapshot,
 													xid_cutoff, multi_cutoff,
 													num_tuples, tups_vacuumed,
-													tups_recently_dead);
+													tups_recently_dead,
+													tableam_data);
 }
 
 /*
diff --git a/src/include/commands/repack.h b/src/include/commands/repack.h
index 07f887e99f6..8af73f8c81f 100644
--- a/src/include/commands/repack.h
+++ b/src/include/commands/repack.h
@@ -17,11 +17,14 @@
 
 #include "access/hio.h"
 #include "access/skey.h"
+#include "access/xlogdefs.h"
 #include "nodes/execnodes.h"
 #include "nodes/parsenodes.h"
 #include "parser/parse_node.h"
+#include "storage/block.h"
 #include "storage/lockdefs.h"
 #include "utils/relcache.h"
+#include "utils/snapshot.h"
 
 
 /* flag bits for ClusterParams->options */
@@ -66,13 +69,14 @@ typedef struct RepackDest
 
 	/* The latest column we need to deform to have the tuple identity */
 	AttrNumber	last_key_attno;
-} RepackDest;
 
-/*
- * The first file exported by the decoding worker must contain a snapshot, the
- * following ones contain the data changes.
- */
-#define WORKER_FILE_SNAPSHOT	0
+	/*
+	 * Range of blocks in the old table the contents of this table comes from.
+	 * Note that range_end is the first block of the next range.
+	 */
+	BlockNumber range_start;
+	BlockNumber range_end;
+} RepackDest;
 
 /*
  * Information needed to apply concurrent data changes.
@@ -84,10 +88,42 @@ typedef struct ChangeContext
 	/* The destination table. */
 	RepackDest	cc_dest;
 
-	/* Sequential number of the file containing the changes. */
-	int			cc_file_seq;
+	/* Sequential number of the file containing snapshot. */
+	int			cc_file_seq_snapshot;
+	/* Sequential number of the file containing data changes. */
+	int			cc_file_seq_changes;
+
+	/*
+	 * Auxiliary table to store ordered tuples temporarily.
+	 *
+	 * When the new relation needs to be clustered, we use this table instead
+	 * of tuplesort. The problem with a tuplesort is that data changes need to
+	 * be applied at range boundary (see heapam_relation_copy_for_cluster()
+	 * for more information), however it's not possible to look-up and change
+	 * tuples in tuplestore.
+	 *
+	 * Once the contents of the REPACKed table has been copied into the
+	 * auxiliary table, we build the clustering index (unless it's the same as
+	 * the identity index) and scan it to get the tuple in the desired order.
+	 * XXX Is it worth putting the contents into a tuplestore and sorting it?
+	 * Not sure, it'd require disk space for one more copy and the copying
+	 * itself is not free.
+	 *
+	 * TODO 1) make the tables unlogged, 2) if REPACK locks the TOAST relation
+	 * too (not sure it does) try to preserve TOAST pointers, instead of
+	 * storing them to TOAST relations of these tables, 3) Check that the
+	 * tables are dropped on transaction abort.
+	 */
+	RepackDest *cc_dest_aux;
+
+	/*
+	 * The index that defines ordering of the old table.
+	 */
+	Oid			cc_clustering_index;
 } ChangeContext;
 
+extern PGDLLIMPORT int repack_pages_per_snapshot;
+
 extern void ExecRepack(ParseState *pstate, RepackStmt *stmt, bool isTopLevel);
 
 extern void cluster_rel(RepackCommand cmd, Relation OldHeap, Oid indexOid,
@@ -98,9 +134,8 @@ extern void mark_index_clustered(Relation rel, Oid indexOid, bool is_internal);
 
 extern Oid	make_new_heap(Oid OIDOldHeap, Oid NewTableSpace, Oid NewAccessMethod,
 						  char relpersistence, LOCKMODE lockmode);
-extern void heap_insert_for_repack(Relation rel, TupleTableSlot *src,
-								   TupleTableSlot *reform,
-								   BulkInsertStateData *bistate);
+extern void heap_insert_for_repack(ChangeContext *chgcxt, TupleTableSlot *src,
+								   TupleTableSlot *reform);
 extern bool tuple_needs_reform(HeapTuple tuple, TupleDesc tupDesc);
 extern void clear_dropped_attributes(HeapTuple tuple, TupleTableSlot *reform);
 extern void finish_heap_swap(Oid OIDOldHeap, Oid OIDNewHeap,
@@ -112,7 +147,12 @@ extern void finish_heap_swap(Oid OIDOldHeap, Oid OIDNewHeap,
 							 TransactionId frozenXid,
 							 MultiXactId cutoffMulti,
 							 char newrelpersistence);
-
+extern Snapshot repack_get_snapshot(ChangeContext *chgcxt);
+extern void repack_process_concurrent_changes(ChangeContext *chgcxt,
+											  XLogRecPtr end_of_wal,
+											  BlockNumber range_start,
+											  BlockNumber range_end,
+											  bool request_snapshot, bool done);
 extern void HandleRepackMessageInterrupt(void);
 extern void ProcessRepackMessages(void);
 
diff --git a/src/include/commands/repack_internal.h b/src/include/commands/repack_internal.h
index 42111aa4ae3..8003e999864 100644
--- a/src/include/commands/repack_internal.h
+++ b/src/include/commands/repack_internal.h
@@ -44,6 +44,8 @@ typedef struct RepackDecodingState
 
 	/* Per-change memory context. */
 	MemoryContext change_cxt;
+	/* Per-snapshot memory context. */
+	MemoryContext snapshot_cxt;
 
 	/* A tuple slot used to pass tuples back and forth */
 	TupleTableSlot *slot;
@@ -67,6 +69,9 @@ typedef struct DecodingWorkerShared
 	/* Is the decoding initialized? */
 	bool		initialized;
 
+	/* Set to request a snapshot. */
+	bool		snapshot_requested;
+
 	/*
 	 * Once the worker has reached this LSN, it should close the current
 	 * output file and either create a new one or exit, according to the field
@@ -74,6 +79,8 @@ typedef struct DecodingWorkerShared
 	 * the WAL available and keep checking this field. It is ok if the worker
 	 * had already decoded records whose LSN is >= lsn_upto before this field
 	 * has been set.
+	 *
+	 * Set a valid LSN to request data changes.
 	 */
 	XLogRecPtr	lsn_upto;
 
@@ -84,7 +91,8 @@ typedef struct DecodingWorkerShared
 	SharedFileSet sfs;
 
 	/* Number of the last file exported by the worker. */
-	int			last_exported;
+	int			last_exported_snapshot;
+	int			last_exported_changes;
 
 	/* Synchronize access to the fields above. */
 	slock_t		mutex;
@@ -116,7 +124,8 @@ typedef struct DecodingWorkerShared
 	char		error_queue[FLEXIBLE_ARRAY_MEMBER];
 } DecodingWorkerShared;
 
-extern void DecodingWorkerFileName(char *fname, Oid relid, uint32 seq);
+extern void DecodingWorkerFileName(char *fname, Oid relid, uint32 seq,
+								   bool snapshot);
 
 
 #endif							/* REPACK_INTERNAL_H */
diff --git a/src/include/replication/logical.h b/src/include/replication/logical.h
index 6e0b7628001..37315a424e0 100644
--- a/src/include/replication/logical.h
+++ b/src/include/replication/logical.h
@@ -138,7 +138,7 @@ extern bool DecodingContextReady(LogicalDecodingContext *ctx);
 extern void FreeDecodingContext(LogicalDecodingContext *ctx);
 
 extern void LogicalIncreaseXminForSlot(XLogRecPtr current_lsn,
-									   TransactionId xmin);
+									   TransactionId xmin, bool catalog);
 extern void LogicalIncreaseRestartDecodingForSlot(XLogRecPtr current_lsn,
 												  XLogRecPtr restart_lsn);
 extern void LogicalConfirmReceivedLocation(XLogRecPtr lsn);
diff --git a/src/include/replication/reorderbuffer.h b/src/include/replication/reorderbuffer.h
index ff825e4b7b2..cdefc4808df 100644
--- a/src/include/replication/reorderbuffer.h
+++ b/src/include/replication/reorderbuffer.h
@@ -104,6 +104,12 @@ typedef struct ReorderBufferChange
 			HeapTuple	oldtuple;
 			/* valid for INSERT || UPDATE */
 			HeapTuple	newtuple;
+
+			/*
+			 * valid for UPDATE - this is the physical location of the old
+			 * tuple version, valid even if 'oldtuple' is NULL.
+			 */
+			BlockNumber old_blknum;
 		}			tp;
 
 		/*
@@ -763,6 +769,7 @@ extern void ReorderBufferProcessXid(ReorderBuffer *rb, TransactionId xid, XLogRe
 
 extern void ReorderBufferXidSetCatalogChanges(ReorderBuffer *rb, TransactionId xid, XLogRecPtr lsn);
 extern bool ReorderBufferXidHasCatalogChanges(ReorderBuffer *rb, TransactionId xid);
+extern bool ReorderBufferXidHasHeapChanges(ReorderBuffer *rb, TransactionId xid);
 extern bool ReorderBufferXidHasBaseSnapshot(ReorderBuffer *rb, TransactionId xid);
 
 extern bool ReorderBufferRememberPrepareInfo(ReorderBuffer *rb, TransactionId xid,
diff --git a/src/test/modules/injection_points/Makefile b/src/test/modules/injection_points/Makefile
index c01d2fb095c..9c942599c49 100644
--- a/src/test/modules/injection_points/Makefile
+++ b/src/test/modules/injection_points/Makefile
@@ -15,6 +15,7 @@ REGRESS_OPTS = --dlpath=$(top_builddir)/src/test/regress
 ISOLATION = basic \
 	    inplace \
 	    repack \
+	    repack_snapshots \
 	    repack_temporal \
 	    repack_temporal_multirange \
 	    repack_toast \
diff --git a/src/test/modules/injection_points/meson.build b/src/test/modules/injection_points/meson.build
index 59dba1cb023..d432a6b8f76 100644
--- a/src/test/modules/injection_points/meson.build
+++ b/src/test/modules/injection_points/meson.build
@@ -46,6 +46,7 @@ tests += {
       'basic',
       'inplace',
       'repack',
+      'repack_snapshots',
       'repack_temporal',
       'repack_temporal_multirange',
       'repack_toast',
diff --git a/src/test/modules/injection_points/specs/repack_snapshots.spec b/src/test/modules/injection_points/specs/repack_snapshots.spec
new file mode 100644
index 00000000000..0706e25a6e7
--- /dev/null
+++ b/src/test/modules/injection_points/specs/repack_snapshots.spec
@@ -0,0 +1,235 @@
+# REPACK (CONCURRENTLY) - use one snapshot per block range.
+setup
+{
+	CREATE EXTENSION injection_points;
+
+	CREATE TABLE repack_test(i int PRIMARY KEY, j text);
+	CREATE INDEX ON repack_test(i DESC);
+	CREATE TABLE relfilenodes(node oid);
+
+	CREATE TABLE data_s1(i int, j text);
+	CREATE TABLE data_s2(i int, j text);
+
+	-- Keep inserting tuples into repack_test until several tuples need to
+        -- be inserted into block number last_block.
+	CREATE FUNCTION load(last_block int)
+	RETURNS void
+	LANGUAGE 'plpgsql'
+	AS $$
+	    DECLARE
+		cnt	int;
+	    BEGIN
+		INSERT INTO repack_test VALUES (1, gen_external());
+
+		LOOP
+		    WITH max(m) AS (SELECT max(i) FROM repack_test)
+		    INSERT INTO repack_test(i, j)
+		    SELECT m + x, gen_external()
+		    FROM generate_series(1, 100) s(x), max;
+
+		    SELECT count(*)
+		    FROM repack_test WHERE tid_block(ctid) = last_block
+		    INTO cnt;
+
+		    IF cnt >= 10 THEN
+			EXIT;
+		    END IF;
+		END LOOP;
+	    END;
+	$$;
+
+	-- Generate a string of random characters that is not likely to be
+	-- compressed, but is big enough to be stored externally.
+	CREATE FUNCTION gen_external()
+	RETURNS text
+	LANGUAGE sql as $$
+		SELECT string_agg(chr(65 + trunc(25 * random())::int), '')
+		FROM generate_series(1, 2048) s(x);
+	$$;
+}
+
+teardown
+{
+	DROP TABLE repack_test;
+	DROP EXTENSION injection_points;
+
+	DROP TABLE relfilenodes;
+	DROP TABLE data_s1;
+	DROP TABLE data_s2;
+
+	DROP FUNCTION load(int);
+	DROP FUNCTION gen_external();
+}
+
+session s1
+setup
+{
+	SET repack_snapshot_after = 1;
+
+	SELECT injection_points_set_local();
+	SELECT injection_points_attach('repack-concurrently-new-range', 'wait');
+}
+# The most practical way to test the corner cases is to set range size to 1
+# block. To initialize, insert new tuples until we have several tuples in the
+# 2nd block.
+step load
+{
+	SELECT load(1);
+}
+# Start the initial load and wait when the first range has been completed.
+step repack
+{
+	REPACK (CONCURRENTLY) repack_test;
+}
+# The same, but with clustering.
+step repack_pkey
+{
+	REPACK (CONCURRENTLY) repack_test USING INDEX repack_test_pkey;
+}
+# Clustering by other than the identity index.
+step repack_other_index
+{
+	REPACK (CONCURRENTLY) repack_test USING INDEX repack_test_i_idx;
+}
+# Check the table from the perspective of s1.
+step check1
+{
+	INSERT INTO data_s1(i, j)
+	SELECT i, j FROM repack_test;
+
+	SELECT count(*) > 0 FROM repack_test;
+
+	SELECT count(*)
+	FROM data_s1 d1 FULL JOIN data_s2 d2 USING (i, j)
+	WHERE d1.i ISNULL OR d2.i ISNULL;
+}
+# Check the ordering where appropriate. We don't know the exact number of
+# rows, so just check a sample. (The replayed concurrent changes are not
+# ordered, but those shouldn't fit into the first 10 rows.)
+step check1_order_asc
+{
+	SELECT i FROM repack_test LIMIT 10;
+}
+# Due to the special way of loading the data (see the load() function above)
+# we don't know the maximum value. To make the test output deterministic,
+# check for cases where the current row is not lower than the previous row.
+step check1_order_desc
+{
+	WITH tmp(diff) as (
+		SELECT i - lag(i, 1, 10000) OVER (ORDER BY ctid)
+		FROM repack_test
+		LIMIT 10)
+	SELECT * FROM tmp WHERE diff > -1;
+}
+teardown
+{
+	SELECT injection_points_detach('repack-concurrently-new-range');
+}
+
+session s2
+# Test processing of changes such that the new tuple is beyond the current
+# range. Specifically for UPDATE, the old tuple should be in the current
+# range. So when applying it, we have to convert it to DELETE.
+step change_new_beyond
+{
+	INSERT INTO repack_test
+	SELECT max(i) + 1, gen_external()
+	FROM repack_test
+	RETURNING tid_block(ctid);
+
+	UPDATE repack_test SET j = gen_external()
+	WHERE ctid=(SELECT min(ctid) FROM repack_test)
+	RETURNING tid_block(OLD.ctid), tid_block(NEW.ctid);
+}
+# Test processing of changes such that the old tuple is beyond the current
+# range. The UPDATE puts also the new tuple beyond the current range.
+step change_old_beyond
+{
+	DELETE FROM repack_test
+	WHERE ctid=(SELECT max(ctid) FROM repack_test)
+	RETURNING tid_block(ctid);
+
+	UPDATE repack_test SET j = gen_external()
+	WHERE ctid=(SELECT max(ctid) FROM repack_test)
+	RETURNING tid_block(OLD.ctid), tid_block(NEW.ctid);
+}
+# Arrange for UPDATE to put the new tuples into block 0. In particular, fill
+# the block 1 and delete some tuples from block 1.
+step load2
+{
+	SELECT load(2);
+
+	DELETE FROM repack_test WHERE i < 100;
+}
+# Logically this belongs to the previous step, however VACUUM cannot run
+# inside a transaction block.
+step load2_vacuum
+{
+	VACUUM repack_test;
+}
+# This UPDATE should put the new tuple into block 0 (the current range). So
+# when replaying it, we have to convert it to INSERT. That includes fetching
+# the old tuple's TOAST from the TOAST table because the old tuple is not
+# available during the replay.
+step change_old_beyond2
+{
+	UPDATE repack_test SET j = gen_external()
+	WHERE ctid=(SELECT max(ctid) FROM repack_test WHERE tid_block(ctid) = 1)
+	RETURNING tid_block(OLD.ctid), tid_block(NEW.ctid);
+}
+# Check the table from the perspective of s4.
+step check2
+{
+	INSERT INTO data_s2(i, j)
+	SELECT i, j FROM repack_test;
+}
+step wakeup_new_range
+{
+	SELECT injection_points_wakeup('repack-concurrently-new-range');
+}
+
+# Test if snapshots are used correctly to scan block ranges.
+permutation
+	load
+	repack
+	change_new_beyond
+	change_old_beyond
+	check2
+	wakeup_new_range
+	check1
+
+# Special attention is needed to update tuple in block 1 so that the new tuple
+# appears in block 0. The preparation includes VACUUM, which in turn cannot
+# proceed while REPACK is in progress. That's why we need a separate
+# permutation. Note that two wake-ups are needed as we have two range
+# boundaries now.
+permutation
+	load2
+	load2_vacuum
+	repack
+	change_old_beyond2
+	check2
+	wakeup_new_range
+	wakeup_new_range
+	check1
+
+# The first permutation with identity index as the clustering index.
+permutation
+	load
+	repack_pkey
+	change_new_beyond
+	change_old_beyond
+	check2
+	wakeup_new_range
+	check1
+	check1_order_asc
+# The first permutation with another clustering index.
+permutation
+	load
+	repack_other_index
+	change_new_beyond
+	change_old_beyond
+	check2
+	wakeup_new_range
+	check1
+	check1_order_desc
-- 
2.52.0

